DROP TABLE type_test;
DROP SEQUENCE type_test_id_seq;
DROP FUNCTION testFunc(INTEGER, INTEGER);                                                                                                               
                                                                                                               
CREATE TABLE type_test
(
  id                            SERIAL,
  description                   VARCHAR(100) NOT NULL,
                                                                                                               
  t_SMALLINT                    SMALLINT,
  t_INTEGER                     INTEGER,
  t_BIGINT                      BIGINT,
                                                                                                               
  t_NUMERIC                     NUMERIC(10,5),
  t_REAL                        REAL,
  t_DOUBLE_PRECISION            DOUBLE PRECISION,
                                                                                                               
  t_CHAR                        CHAR(100),
  t_VARCHAR                     VARCHAR(255),
  t_TEXT                        TEXT,
                                                                                                               
  t_TIMESTAMP                   TIMESTAMP,
  t_TIMESTAMPTZ                 TIMESTAMP WITH TIME ZONE, 
  t_INTERVAL                    INTERVAL,
  t_DATE                        DATE,
  t_TIME                        TIME,
                                                                                                               
  t_BOOLEAN                     BOOLEAN,

  t_BINARY                      BYTEA
);

INSERT INTO type_test (id, description, t_SMALLINT, t_INTEGER, t_BIGINT)
       VALUES(2147483647, '1: Integer Types', -32768, 2147483647, -9223372036854775800);
INSERT INTO type_test (description, t_NUMERIC, t_REAL, t_DOUBLE_PRECISION)
       VALUES('2: Floating Point Types', 9871.2345, 9999.1234567, 1000.1234567890123456);
INSERT INTO type_test (description, t_CHAR, t_VARCHAR, t_TEXT)
       VALUES('3: Character Types', 'This is a char', '345 Elm Street', 'Lots of text: dsjlsadlkjsdlkjsdlkasjdlskadjsaljdlskajdlskjdlskadjlskdjlskhsdjhfgjhhsahlsajdlkasjdlskajdlsajd;sajlkfldsfhdshfdfsfsdhfjsdhfksdfksdfksdfdassdaslkdjsakldj THE END OF THE TEXT THINGY');
INSERT INTO type_test (description, t_TIMESTAMP, t_TIMESTAMPTZ, t_INTERVAL, t_DATE, t_TIME)
       VALUES('4: Date & Time Types', '1999-12-31 23:59:59', '1999-12-31 23:59:59+02:00', '50 year ago', '2020-12-31', '18:59:59');
INSERT INTO type_test (description, t_BOOLEAN)
       VALUES('5: Boolean Types', TRUE);
INSERT INTO type_test (description, t_BINARY)
       VALUES('6: Binary Types', 'Test [\\300]ABCD\\000');

CREATE FUNCTION testFunc(INTEGER, INTEGER)
RETURNS INTEGER
AS
'
   SELECT $1 + ($2  / 2);  
' 
LANGUAGE SQL;

